import { Construct } from 'constructs';
export interface KinesisVideoStreamPoolTag {
    readonly key: string;
    readonly value: string;
}
export interface KinesisVideoStreamConfiguration {
    readonly dataRetentionInHours?: number;
    readonly region: string;
}
export interface KinesisVideoStreamPoolProps {
    readonly poolName?: string;
    readonly streamConfiguration: KinesisVideoStreamConfiguration;
    readonly tags?: Array<KinesisVideoStreamPoolTag>;
    readonly clientRequestToken?: string;
}
export declare class KinesisVideoStreamPool extends Construct {
    readonly createdTimestamp: string;
    readonly poolArn: string;
    readonly poolId: string;
    readonly poolName: string;
    readonly poolStatus: string;
    readonly updatedTimestamp: string;
    constructor(scope: Construct, id: string, props: KinesisVideoStreamPoolProps);
}
