import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateAppInstanceUserRequestFilterSensitiveLog, } from "../models/models_0";
import { de_CreateAppInstanceUserCommand, se_CreateAppInstanceUserCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateAppInstanceUserCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "CreateAppInstanceUser", {})
    .n("ChimeSDKIdentityClient", "CreateAppInstanceUserCommand")
    .f(CreateAppInstanceUserRequestFilterSensitiveLog, void 0)
    .ser(se_CreateAppInstanceUserCommand)
    .de(de_CreateAppInstanceUserCommand)
    .build() {
}
