import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateAppInstanceUserEndpointRequestFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateAppInstanceUserEndpointCommand, se_UpdateAppInstanceUserEndpointCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateAppInstanceUserEndpointCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "UpdateAppInstanceUserEndpoint", {})
    .n("ChimeSDKIdentityClient", "UpdateAppInstanceUserEndpointCommand")
    .f(UpdateAppInstanceUserEndpointRequestFilterSensitiveLog, void 0)
    .ser(se_UpdateAppInstanceUserEndpointCommand)
    .de(de_UpdateAppInstanceUserEndpointCommand)
    .build() {
}
