import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateMediaInsightsPipelineRequestFilterSensitiveLog, CreateMediaInsightsPipelineResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateMediaInsightsPipelineCommand, se_CreateMediaInsightsPipelineCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateMediaInsightsPipelineCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "CreateMediaInsightsPipeline", {})
    .n("ChimeSDKMediaPipelinesClient", "CreateMediaInsightsPipelineCommand")
    .f(CreateMediaInsightsPipelineRequestFilterSensitiveLog, CreateMediaInsightsPipelineResponseFilterSensitiveLog)
    .ser(se_CreateMediaInsightsPipelineCommand)
    .de(de_CreateMediaInsightsPipelineCommand)
    .build() {
}
