import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetMediaCapturePipelineResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetMediaCapturePipelineCommand, se_GetMediaCapturePipelineCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetMediaCapturePipelineCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "GetMediaCapturePipeline", {})
    .n("ChimeSDKMediaPipelinesClient", "GetMediaCapturePipelineCommand")
    .f(void 0, GetMediaCapturePipelineResponseFilterSensitiveLog)
    .ser(se_GetMediaCapturePipelineCommand)
    .de(de_GetMediaCapturePipelineCommand)
    .build() {
}
