import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetMediaInsightsPipelineConfigurationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetMediaInsightsPipelineConfigurationCommand, se_GetMediaInsightsPipelineConfigurationCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class GetMediaInsightsPipelineConfigurationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "GetMediaInsightsPipelineConfiguration", {})
    .n("ChimeSDKMediaPipelinesClient", "GetMediaInsightsPipelineConfigurationCommand")
    .f(void 0, GetMediaInsightsPipelineConfigurationResponseFilterSensitiveLog)
    .ser(se_GetMediaInsightsPipelineConfigurationCommand)
    .de(de_GetMediaInsightsPipelineConfigurationCommand)
    .build() {
}
