import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListMediaInsightsPipelineConfigurationsResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListMediaInsightsPipelineConfigurationsCommand, se_ListMediaInsightsPipelineConfigurationsCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class ListMediaInsightsPipelineConfigurationsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "ListMediaInsightsPipelineConfigurations", {})
    .n("ChimeSDKMediaPipelinesClient", "ListMediaInsightsPipelineConfigurationsCommand")
    .f(void 0, ListMediaInsightsPipelineConfigurationsResponseFilterSensitiveLog)
    .ser(se_ListMediaInsightsPipelineConfigurationsCommand)
    .de(de_ListMediaInsightsPipelineConfigurationsCommand)
    .build() {
}
