import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { CreateMediaCapturePipelineCommandInput, CreateMediaCapturePipelineCommandOutput } from "../commands/CreateMediaCapturePipelineCommand";
import { CreateMediaConcatenationPipelineCommandInput, CreateMediaConcatenationPipelineCommandOutput } from "../commands/CreateMediaConcatenationPipelineCommand";
import { CreateMediaInsightsPipelineCommandInput, CreateMediaInsightsPipelineCommandOutput } from "../commands/CreateMediaInsightsPipelineCommand";
import { CreateMediaInsightsPipelineConfigurationCommandInput, CreateMediaInsightsPipelineConfigurationCommandOutput } from "../commands/CreateMediaInsightsPipelineConfigurationCommand";
import { CreateMediaLiveConnectorPipelineCommandInput, CreateMediaLiveConnectorPipelineCommandOutput } from "../commands/CreateMediaLiveConnectorPipelineCommand";
import { CreateMediaPipelineKinesisVideoStreamPoolCommandInput, CreateMediaPipelineKinesisVideoStreamPoolCommandOutput } from "../commands/CreateMediaPipelineKinesisVideoStreamPoolCommand";
import { CreateMediaStreamPipelineCommandInput, CreateMediaStreamPipelineCommandOutput } from "../commands/CreateMediaStreamPipelineCommand";
import { DeleteMediaCapturePipelineCommandInput, DeleteMediaCapturePipelineCommandOutput } from "../commands/DeleteMediaCapturePipelineCommand";
import { DeleteMediaInsightsPipelineConfigurationCommandInput, DeleteMediaInsightsPipelineConfigurationCommandOutput } from "../commands/DeleteMediaInsightsPipelineConfigurationCommand";
import { DeleteMediaPipelineCommandInput, DeleteMediaPipelineCommandOutput } from "../commands/DeleteMediaPipelineCommand";
import { DeleteMediaPipelineKinesisVideoStreamPoolCommandInput, DeleteMediaPipelineKinesisVideoStreamPoolCommandOutput } from "../commands/DeleteMediaPipelineKinesisVideoStreamPoolCommand";
import { GetMediaCapturePipelineCommandInput, GetMediaCapturePipelineCommandOutput } from "../commands/GetMediaCapturePipelineCommand";
import { GetMediaInsightsPipelineConfigurationCommandInput, GetMediaInsightsPipelineConfigurationCommandOutput } from "../commands/GetMediaInsightsPipelineConfigurationCommand";
import { GetMediaPipelineCommandInput, GetMediaPipelineCommandOutput } from "../commands/GetMediaPipelineCommand";
import { GetMediaPipelineKinesisVideoStreamPoolCommandInput, GetMediaPipelineKinesisVideoStreamPoolCommandOutput } from "../commands/GetMediaPipelineKinesisVideoStreamPoolCommand";
import { GetSpeakerSearchTaskCommandInput, GetSpeakerSearchTaskCommandOutput } from "../commands/GetSpeakerSearchTaskCommand";
import { GetVoiceToneAnalysisTaskCommandInput, GetVoiceToneAnalysisTaskCommandOutput } from "../commands/GetVoiceToneAnalysisTaskCommand";
import { ListMediaCapturePipelinesCommandInput, ListMediaCapturePipelinesCommandOutput } from "../commands/ListMediaCapturePipelinesCommand";
import { ListMediaInsightsPipelineConfigurationsCommandInput, ListMediaInsightsPipelineConfigurationsCommandOutput } from "../commands/ListMediaInsightsPipelineConfigurationsCommand";
import { ListMediaPipelineKinesisVideoStreamPoolsCommandInput, ListMediaPipelineKinesisVideoStreamPoolsCommandOutput } from "../commands/ListMediaPipelineKinesisVideoStreamPoolsCommand";
import { ListMediaPipelinesCommandInput, ListMediaPipelinesCommandOutput } from "../commands/ListMediaPipelinesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { StartSpeakerSearchTaskCommandInput, StartSpeakerSearchTaskCommandOutput } from "../commands/StartSpeakerSearchTaskCommand";
import { StartVoiceToneAnalysisTaskCommandInput, StartVoiceToneAnalysisTaskCommandOutput } from "../commands/StartVoiceToneAnalysisTaskCommand";
import { StopSpeakerSearchTaskCommandInput, StopSpeakerSearchTaskCommandOutput } from "../commands/StopSpeakerSearchTaskCommand";
import { StopVoiceToneAnalysisTaskCommandInput, StopVoiceToneAnalysisTaskCommandOutput } from "../commands/StopVoiceToneAnalysisTaskCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateMediaInsightsPipelineConfigurationCommandInput, UpdateMediaInsightsPipelineConfigurationCommandOutput } from "../commands/UpdateMediaInsightsPipelineConfigurationCommand";
import { UpdateMediaInsightsPipelineStatusCommandInput, UpdateMediaInsightsPipelineStatusCommandOutput } from "../commands/UpdateMediaInsightsPipelineStatusCommand";
import { UpdateMediaPipelineKinesisVideoStreamPoolCommandInput, UpdateMediaPipelineKinesisVideoStreamPoolCommandOutput } from "../commands/UpdateMediaPipelineKinesisVideoStreamPoolCommand";
/**
 * serializeAws_restJson1CreateMediaCapturePipelineCommand
 */
export declare const se_CreateMediaCapturePipelineCommand: (input: CreateMediaCapturePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateMediaConcatenationPipelineCommand
 */
export declare const se_CreateMediaConcatenationPipelineCommand: (input: CreateMediaConcatenationPipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateMediaInsightsPipelineCommand
 */
export declare const se_CreateMediaInsightsPipelineCommand: (input: CreateMediaInsightsPipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateMediaInsightsPipelineConfigurationCommand
 */
export declare const se_CreateMediaInsightsPipelineConfigurationCommand: (input: CreateMediaInsightsPipelineConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateMediaLiveConnectorPipelineCommand
 */
export declare const se_CreateMediaLiveConnectorPipelineCommand: (input: CreateMediaLiveConnectorPipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateMediaPipelineKinesisVideoStreamPoolCommand
 */
export declare const se_CreateMediaPipelineKinesisVideoStreamPoolCommand: (input: CreateMediaPipelineKinesisVideoStreamPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateMediaStreamPipelineCommand
 */
export declare const se_CreateMediaStreamPipelineCommand: (input: CreateMediaStreamPipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteMediaCapturePipelineCommand
 */
export declare const se_DeleteMediaCapturePipelineCommand: (input: DeleteMediaCapturePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteMediaInsightsPipelineConfigurationCommand
 */
export declare const se_DeleteMediaInsightsPipelineConfigurationCommand: (input: DeleteMediaInsightsPipelineConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteMediaPipelineCommand
 */
export declare const se_DeleteMediaPipelineCommand: (input: DeleteMediaPipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteMediaPipelineKinesisVideoStreamPoolCommand
 */
export declare const se_DeleteMediaPipelineKinesisVideoStreamPoolCommand: (input: DeleteMediaPipelineKinesisVideoStreamPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetMediaCapturePipelineCommand
 */
export declare const se_GetMediaCapturePipelineCommand: (input: GetMediaCapturePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetMediaInsightsPipelineConfigurationCommand
 */
export declare const se_GetMediaInsightsPipelineConfigurationCommand: (input: GetMediaInsightsPipelineConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetMediaPipelineCommand
 */
export declare const se_GetMediaPipelineCommand: (input: GetMediaPipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetMediaPipelineKinesisVideoStreamPoolCommand
 */
export declare const se_GetMediaPipelineKinesisVideoStreamPoolCommand: (input: GetMediaPipelineKinesisVideoStreamPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetSpeakerSearchTaskCommand
 */
export declare const se_GetSpeakerSearchTaskCommand: (input: GetSpeakerSearchTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetVoiceToneAnalysisTaskCommand
 */
export declare const se_GetVoiceToneAnalysisTaskCommand: (input: GetVoiceToneAnalysisTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListMediaCapturePipelinesCommand
 */
export declare const se_ListMediaCapturePipelinesCommand: (input: ListMediaCapturePipelinesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListMediaInsightsPipelineConfigurationsCommand
 */
export declare const se_ListMediaInsightsPipelineConfigurationsCommand: (input: ListMediaInsightsPipelineConfigurationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListMediaPipelineKinesisVideoStreamPoolsCommand
 */
export declare const se_ListMediaPipelineKinesisVideoStreamPoolsCommand: (input: ListMediaPipelineKinesisVideoStreamPoolsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListMediaPipelinesCommand
 */
export declare const se_ListMediaPipelinesCommand: (input: ListMediaPipelinesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StartSpeakerSearchTaskCommand
 */
export declare const se_StartSpeakerSearchTaskCommand: (input: StartSpeakerSearchTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StartVoiceToneAnalysisTaskCommand
 */
export declare const se_StartVoiceToneAnalysisTaskCommand: (input: StartVoiceToneAnalysisTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StopSpeakerSearchTaskCommand
 */
export declare const se_StopSpeakerSearchTaskCommand: (input: StopSpeakerSearchTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StopVoiceToneAnalysisTaskCommand
 */
export declare const se_StopVoiceToneAnalysisTaskCommand: (input: StopVoiceToneAnalysisTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateMediaInsightsPipelineConfigurationCommand
 */
export declare const se_UpdateMediaInsightsPipelineConfigurationCommand: (input: UpdateMediaInsightsPipelineConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateMediaInsightsPipelineStatusCommand
 */
export declare const se_UpdateMediaInsightsPipelineStatusCommand: (input: UpdateMediaInsightsPipelineStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateMediaPipelineKinesisVideoStreamPoolCommand
 */
export declare const se_UpdateMediaPipelineKinesisVideoStreamPoolCommand: (input: UpdateMediaPipelineKinesisVideoStreamPoolCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_restJson1CreateMediaCapturePipelineCommand
 */
export declare const de_CreateMediaCapturePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateMediaCapturePipelineCommandOutput>;
/**
 * deserializeAws_restJson1CreateMediaConcatenationPipelineCommand
 */
export declare const de_CreateMediaConcatenationPipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateMediaConcatenationPipelineCommandOutput>;
/**
 * deserializeAws_restJson1CreateMediaInsightsPipelineCommand
 */
export declare const de_CreateMediaInsightsPipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateMediaInsightsPipelineCommandOutput>;
/**
 * deserializeAws_restJson1CreateMediaInsightsPipelineConfigurationCommand
 */
export declare const de_CreateMediaInsightsPipelineConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateMediaInsightsPipelineConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1CreateMediaLiveConnectorPipelineCommand
 */
export declare const de_CreateMediaLiveConnectorPipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateMediaLiveConnectorPipelineCommandOutput>;
/**
 * deserializeAws_restJson1CreateMediaPipelineKinesisVideoStreamPoolCommand
 */
export declare const de_CreateMediaPipelineKinesisVideoStreamPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateMediaPipelineKinesisVideoStreamPoolCommandOutput>;
/**
 * deserializeAws_restJson1CreateMediaStreamPipelineCommand
 */
export declare const de_CreateMediaStreamPipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateMediaStreamPipelineCommandOutput>;
/**
 * deserializeAws_restJson1DeleteMediaCapturePipelineCommand
 */
export declare const de_DeleteMediaCapturePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteMediaCapturePipelineCommandOutput>;
/**
 * deserializeAws_restJson1DeleteMediaInsightsPipelineConfigurationCommand
 */
export declare const de_DeleteMediaInsightsPipelineConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteMediaInsightsPipelineConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1DeleteMediaPipelineCommand
 */
export declare const de_DeleteMediaPipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteMediaPipelineCommandOutput>;
/**
 * deserializeAws_restJson1DeleteMediaPipelineKinesisVideoStreamPoolCommand
 */
export declare const de_DeleteMediaPipelineKinesisVideoStreamPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteMediaPipelineKinesisVideoStreamPoolCommandOutput>;
/**
 * deserializeAws_restJson1GetMediaCapturePipelineCommand
 */
export declare const de_GetMediaCapturePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMediaCapturePipelineCommandOutput>;
/**
 * deserializeAws_restJson1GetMediaInsightsPipelineConfigurationCommand
 */
export declare const de_GetMediaInsightsPipelineConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMediaInsightsPipelineConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1GetMediaPipelineCommand
 */
export declare const de_GetMediaPipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMediaPipelineCommandOutput>;
/**
 * deserializeAws_restJson1GetMediaPipelineKinesisVideoStreamPoolCommand
 */
export declare const de_GetMediaPipelineKinesisVideoStreamPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMediaPipelineKinesisVideoStreamPoolCommandOutput>;
/**
 * deserializeAws_restJson1GetSpeakerSearchTaskCommand
 */
export declare const de_GetSpeakerSearchTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSpeakerSearchTaskCommandOutput>;
/**
 * deserializeAws_restJson1GetVoiceToneAnalysisTaskCommand
 */
export declare const de_GetVoiceToneAnalysisTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetVoiceToneAnalysisTaskCommandOutput>;
/**
 * deserializeAws_restJson1ListMediaCapturePipelinesCommand
 */
export declare const de_ListMediaCapturePipelinesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListMediaCapturePipelinesCommandOutput>;
/**
 * deserializeAws_restJson1ListMediaInsightsPipelineConfigurationsCommand
 */
export declare const de_ListMediaInsightsPipelineConfigurationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListMediaInsightsPipelineConfigurationsCommandOutput>;
/**
 * deserializeAws_restJson1ListMediaPipelineKinesisVideoStreamPoolsCommand
 */
export declare const de_ListMediaPipelineKinesisVideoStreamPoolsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListMediaPipelineKinesisVideoStreamPoolsCommandOutput>;
/**
 * deserializeAws_restJson1ListMediaPipelinesCommand
 */
export declare const de_ListMediaPipelinesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListMediaPipelinesCommandOutput>;
/**
 * deserializeAws_restJson1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_restJson1StartSpeakerSearchTaskCommand
 */
export declare const de_StartSpeakerSearchTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartSpeakerSearchTaskCommandOutput>;
/**
 * deserializeAws_restJson1StartVoiceToneAnalysisTaskCommand
 */
export declare const de_StartVoiceToneAnalysisTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartVoiceToneAnalysisTaskCommandOutput>;
/**
 * deserializeAws_restJson1StopSpeakerSearchTaskCommand
 */
export declare const de_StopSpeakerSearchTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopSpeakerSearchTaskCommandOutput>;
/**
 * deserializeAws_restJson1StopVoiceToneAnalysisTaskCommand
 */
export declare const de_StopVoiceToneAnalysisTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopVoiceToneAnalysisTaskCommandOutput>;
/**
 * deserializeAws_restJson1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_restJson1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_restJson1UpdateMediaInsightsPipelineConfigurationCommand
 */
export declare const de_UpdateMediaInsightsPipelineConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateMediaInsightsPipelineConfigurationCommandOutput>;
/**
 * deserializeAws_restJson1UpdateMediaInsightsPipelineStatusCommand
 */
export declare const de_UpdateMediaInsightsPipelineStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateMediaInsightsPipelineStatusCommandOutput>;
/**
 * deserializeAws_restJson1UpdateMediaPipelineKinesisVideoStreamPoolCommand
 */
export declare const de_UpdateMediaPipelineKinesisVideoStreamPoolCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateMediaPipelineKinesisVideoStreamPoolCommandOutput>;
