import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { BatchDeletePhoneNumberResponseFilterSensitiveLog, } from "../models/models_0";
import { de_BatchDeletePhoneNumberCommand, se_BatchDeletePhoneNumberCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class BatchDeletePhoneNumberCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "BatchDeletePhoneNumber", {})
    .n("ChimeSDKVoiceClient", "BatchDeletePhoneNumberCommand")
    .f(void 0, BatchDeletePhoneNumberResponseFilterSensitiveLog)
    .ser(se_BatchDeletePhoneNumberCommand)
    .de(de_BatchDeletePhoneNumberCommand)
    .build() {
}
