import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateProxySessionRequestFilterSensitiveLog, CreateProxySessionResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateProxySessionCommand, se_CreateProxySessionCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateProxySessionCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "CreateProxySession", {})
    .n("ChimeSDKVoiceClient", "CreateProxySessionCommand")
    .f(CreateProxySessionRequestFilterSensitiveLog, CreateProxySessionResponseFilterSensitiveLog)
    .ser(se_CreateProxySessionCommand)
    .de(de_CreateProxySessionCommand)
    .build() {
}
