import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateVoiceProfileResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateVoiceProfileCommand, se_CreateVoiceProfileCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateVoiceProfileCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "CreateVoiceProfile", {})
    .n("ChimeSDKVoiceClient", "CreateVoiceProfileCommand")
    .f(void 0, CreateVoiceProfileResponseFilterSensitiveLog)
    .ser(se_CreateVoiceProfileCommand)
    .de(de_CreateVoiceProfileCommand)
    .build() {
}
