import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DeleteSipMediaApplicationCommand, se_DeleteSipMediaApplicationCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class DeleteSipMediaApplicationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "DeleteSipMediaApplication", {})
    .n("ChimeSDKVoiceClient", "DeleteSipMediaApplicationCommand")
    .f(void 0, void 0)
    .ser(se_DeleteSipMediaApplicationCommand)
    .de(de_DeleteSipMediaApplicationCommand)
    .build() {
}
