import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { DisassociatePhoneNumbersFromVoiceConnectorRequestFilterSensitiveLog, DisassociatePhoneNumbersFromVoiceConnectorResponseFilterSensitiveLog, } from "../models/models_0";
import { de_DisassociatePhoneNumbersFromVoiceConnectorCommand, se_DisassociatePhoneNumbersFromVoiceConnectorCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class DisassociatePhoneNumbersFromVoiceConnectorCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "DisassociatePhoneNumbersFromVoiceConnector", {})
    .n("ChimeSDKVoiceClient", "DisassociatePhoneNumbersFromVoiceConnectorCommand")
    .f(DisassociatePhoneNumbersFromVoiceConnectorRequestFilterSensitiveLog, DisassociatePhoneNumbersFromVoiceConnectorResponseFilterSensitiveLog)
    .ser(se_DisassociatePhoneNumbersFromVoiceConnectorCommand)
    .de(de_DisassociatePhoneNumbersFromVoiceConnectorCommand)
    .build() {
}
