import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { DisassociatePhoneNumbersFromVoiceConnectorGroupRequestFilterSensitiveLog, DisassociatePhoneNumbersFromVoiceConnectorGroupResponseFilterSensitiveLog, } from "../models/models_0";
import { de_DisassociatePhoneNumbersFromVoiceConnectorGroupCommand, se_DisassociatePhoneNumbersFromVoiceConnectorGroupCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class DisassociatePhoneNumbersFromVoiceConnectorGroupCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "DisassociatePhoneNumbersFromVoiceConnectorGroup", {})
    .n("ChimeSDKVoiceClient", "DisassociatePhoneNumbersFromVoiceConnectorGroupCommand")
    .f(DisassociatePhoneNumbersFromVoiceConnectorGroupRequestFilterSensitiveLog, DisassociatePhoneNumbersFromVoiceConnectorGroupResponseFilterSensitiveLog)
    .ser(se_DisassociatePhoneNumbersFromVoiceConnectorGroupCommand)
    .de(de_DisassociatePhoneNumbersFromVoiceConnectorGroupCommand)
    .build() {
}
