import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetProxySessionResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetProxySessionCommand, se_GetProxySessionCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetProxySessionCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "GetProxySession", {})
    .n("ChimeSDKVoiceClient", "GetProxySessionCommand")
    .f(void 0, GetProxySessionResponseFilterSensitiveLog)
    .ser(se_GetProxySessionCommand)
    .de(de_GetProxySessionCommand)
    .build() {
}
