import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetVoiceConnectorTerminationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetVoiceConnectorTerminationCommand, se_GetVoiceConnectorTerminationCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class GetVoiceConnectorTerminationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "GetVoiceConnectorTermination", {})
    .n("ChimeSDKVoiceClient", "GetVoiceConnectorTerminationCommand")
    .f(void 0, GetVoiceConnectorTerminationResponseFilterSensitiveLog)
    .ser(se_GetVoiceConnectorTerminationCommand)
    .de(de_GetVoiceConnectorTerminationCommand)
    .build() {
}
