import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetVoiceProfileResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetVoiceProfileCommand, se_GetVoiceProfileCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetVoiceProfileCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "GetVoiceProfile", {})
    .n("ChimeSDKVoiceClient", "GetVoiceProfileCommand")
    .f(void 0, GetVoiceProfileResponseFilterSensitiveLog)
    .ser(se_GetVoiceProfileCommand)
    .de(de_GetVoiceProfileCommand)
    .build() {
}
