import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListPhoneNumbersResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListPhoneNumbersCommand, se_ListPhoneNumbersCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class ListPhoneNumbersCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "ListPhoneNumbers", {})
    .n("ChimeSDKVoiceClient", "ListPhoneNumbersCommand")
    .f(void 0, ListPhoneNumbersResponseFilterSensitiveLog)
    .ser(se_ListPhoneNumbersCommand)
    .de(de_ListPhoneNumbersCommand)
    .build() {
}
