import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListSipMediaApplicationsResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListSipMediaApplicationsCommand, se_ListSipMediaApplicationsCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class ListSipMediaApplicationsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "ListSipMediaApplications", {})
    .n("ChimeSDKVoiceClient", "ListSipMediaApplicationsCommand")
    .f(void 0, ListSipMediaApplicationsResponseFilterSensitiveLog)
    .ser(se_ListSipMediaApplicationsCommand)
    .de(de_ListSipMediaApplicationsCommand)
    .build() {
}
