import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateVoiceProfileDomainResponseFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateVoiceProfileDomainCommand, se_UpdateVoiceProfileDomainCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateVoiceProfileDomainCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "UpdateVoiceProfileDomain", {})
    .n("ChimeSDKVoiceClient", "UpdateVoiceProfileDomainCommand")
    .f(void 0, UpdateVoiceProfileDomainResponseFilterSensitiveLog)
    .ser(se_UpdateVoiceProfileDomainCommand)
    .de(de_UpdateVoiceProfileDomainCommand)
    .build() {
}
