import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { DescribeEdgeConfigurationOutputFilterSensitiveLog, } from "../models/models_0";
import { de_DescribeEdgeConfigurationCommand, se_DescribeEdgeConfigurationCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class DescribeEdgeConfigurationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("KinesisVideo_20170930", "DescribeEdgeConfiguration", {})
    .n("KinesisVideoClient", "DescribeEdgeConfigurationCommand")
    .f(void 0, DescribeEdgeConfigurationOutputFilterSensitiveLog)
    .ser(se_DescribeEdgeConfigurationCommand)
    .de(de_DescribeEdgeConfigurationCommand)
    .build() {
}
