import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListEdgeAgentConfigurationsOutputFilterSensitiveLog, } from "../models/models_0";
import { de_ListEdgeAgentConfigurationsCommand, se_ListEdgeAgentConfigurationsCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class ListEdgeAgentConfigurationsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("KinesisVideo_20170930", "ListEdgeAgentConfigurations", {})
    .n("KinesisVideoClient", "ListEdgeAgentConfigurationsCommand")
    .f(void 0, ListEdgeAgentConfigurationsOutputFilterSensitiveLog)
    .ser(se_ListEdgeAgentConfigurationsCommand)
    .de(de_ListEdgeAgentConfigurationsCommand)
    .build() {
}
